from ExtensionClass import Base
from ComputedAttribute import ComputedAttribute
from DocumentTemplate.DT_Util import Eval, expr_globals, TemplateDict, \
    InstanceDict

try:
    from DocumentTemplate.DT_Util import cDocument
    class _td(TemplateDict, cDocument):
        pass
    del cDocument

    def NamespaceStack(REQUEST):
        t = _td()
        if hasattr(REQUEST, 'AUTHENTICATED_USER'):
            t.AUTHENTICATED_USER = REQUEST.AUTHENTICATED_USER
        return t

    def setuid(REQUEST,user):
        if not REQUEST.has_key('AUTHENTICATED_USER'):
            REQUEST['AUTHENTICATED_USER'] = user
            user = None
        elif user is None:
            user = REQUEST['AUTHENTICATED_USER']
            del REQUEST.other['AUTHENTICATED_USER']
        else:
            user, REQUEST['AUTHENTICATED_USER'] = REQUEST['AUTHENTICATED_USER'], user
        return user














except ImportError:

    # 2.2 latest doesn't have cDocument, so we know we're on 2.2
    
    from AccessControl import getSecurityManager
    
    class _td(TemplateDict):
        def validate(self, inst, parent, name, value, md):
            return getSecurityManager().validate(inst, parent, name, value)

    def NamespaceStack(REQUEST): return _td()


    class dummyContext:
        def __init__(self,user): self.user = user
        def getOwner(self): return self.user


    def setuid(REQUEST,user):

        sm = getSecurityManager()

        if type(user) is type(()):
            dc,user = user
            sm.removeContext(dc)
        else:
            dc = dummyContext(user)
            sm.addContext(dc)
            
        sc = sm._context  # XXX hack!!!
        user, sc.user = sc.user, user   # swap users
        return dc, user









class Expression(Base):  # Expression object that can be pickled

    def __init__(self, expr):
        self.expr = expr
        
    def _v_expr(self, expr_globals=expr_globals, Eval=Eval):
        self._v_expr = Eval(self.expr, expr_globals)
        return self._v_expr

    _v_expr = ComputedAttribute(_v_expr)

    def __getstate__(self):
        d = self.__dict__.copy()
        if d.has_key('_v_expr'):
            del d['_v_expr']
        return d

    def __setstate__(self, state):
        d = self.__dict__
        d.clear(); d.update(state)
        
    def eval(self,mapping):
        return self._v_expr.eval(mapping)

    def __call__(self,**kw):
        return apply(self._v_expr,(),kw)

    
class Name:
    def __init__(self,name,call=1):
        self.name, self.call = name, call

    def eval(self,md):
        return md.getitem(self.name,self.call)


del Eval, expr_globals, TemplateDict, Base, ComputedAttribute

